#include "glwindow.h"

#include <EGL/egl.h>


/** Make an X window fit for GL. You have to manage the X window yourself! */
class EGLBackend : public GLBackend {
public:
	/** Create a GL window class and find an appropriate visual */
	EGLBackend() : display(EGL_NO_DISPLAY), context(EGL_NO_CONTEXT) {}
	/** Fre all resources */
	virtual ~EGLBackend();
	
	/** Initialize GL backend, choose visual configuration and return the ID */
	virtual VisualID initialize(Display *display);
	
	/** create a GL context for the given window */
	virtual void createContext(Window window);
	
	/** Swap back and front buffers */
	virtual void swapBuffers() const;
	
	/** Set the swap interval */
	virtual void setSwapInterval(int i) const;
private:
	EGLDisplay display;
	EGLConfig  config;
	EGLSurface surface;
	EGLContext context;
};
