#include "glwindow.h"

#include <GL/glx.h>


/** Make an X window fit for GL. You have to manage the X window yourself! */
class GLXBackend : public GLBackend {
public:
	/** Create a GL window class and find an appropriate visual */
	GLXBackend() : display(NULL), context(None) {}
	/** Fre all resources */
	virtual ~GLXBackend();
	
	/** Initialize GL backend, choose visual configuration and return the ID */
	virtual VisualID initialize(Display *display);
	
	/** create a GL context for the given window */
	virtual void createContext(Window window);
	
	/** Swap back and front buffers */
	virtual void swapBuffers() const;
	
	/** Set the swap interval */
	virtual void setSwapInterval(int i) const;
private:
	Display *display;
	XVisualInfo *vi;
	GLXContext context;
	Window window;
	
	PFNGLXSWAPINTERVALMESAPROC funSwapIntervalMesa;
	PFNGLXSWAPINTERVALEXTPROC funSwapIntervalExt;
};
